-- File Name      : Balls_Maker_V1.02.ms
-- Subject        : Creates different Balls
-- Category       : Object
-- Enabled 3DSMax : 3dsmax 4.x
-- Description    : Make A VolleyBall,Soccer ball,Golf Ball,Basket ball & Base Ball Script.
-- Copyright (c) 2000-2001, Kyung-Sin Kim
-- HomePage = http://www.teamjoon.com & http://www.joycg.com
-- godworlds@lycos.co.kr or godworld@kenemi.com or godworld@teamjoon.com or godworld@hanmail.net
-- Downloaded from SCRIPTS@TDP.NU http://tdp.nu/index.shtml

if balls_win != undefined do closerolloutfloater balls_win
balls_win = newRolloutFloater "Ball's Maker V1.02" 250 376
rollout params "Ball's Maker"
(
	button volley_c "Volley Ball" tooltip:"Volley Ball" width: 90 across:2
	button soccer "Soccer Ball" tooltip:"Soccer Ball" width: 90
	button G_Ball "Golf Ball" tooltip:"Golf Ball" width: 90 across:2
	button basket "Basket Ball" tooltip:"Basket Ball" width: 90
	button base_ball "Base Ball" tooltip:"Base Ball" width: 90 across:2
	on volley_c pressed do
		(
			Volley_B = Box lengthsegs:3 widthsegs:3 heightsegs:3 length:50 width:50 height:50 pos:[0,0,0] isSelected:on name:"VolleyBall01"
			Volley_B.pivot = Volley_B.center
			convertto Volley_B editable_mesh
			modPanel.addModToSelection (meshsmooth ()) ui:on
			$.modifiers[#MeshSmooth].iterations = 1
			modPanel.setCurrentObject $
			subobjectLevel = 4
			select $.faces[#{53..54}]
			select $.faces[#{51..54}]
			select $.faces[#{49..54}]
			select $.faces[#{43..44, 49..54}]
			select $.faces[#{43..46, 49..54}]
			select $.faces[#{43..54}]
			select $.faces[#{41..54}]
			select $.faces[#{39..54}]
			select $.faces[#{37..54}]
			subobjectLevel = 0
			modPanel.setCurrentObject $.modifiers[#MeshSmooth]
			modPanel.addModToSelection (Spherify ()) ui:on
			modPanel.addModToSelection (Edit_Mesh ()) ui:on
			subobjectLevel = 4
			max select invert
			convertto Volley_B editable_mesh
			subobjectLevel = 4
			delete $.selectedfaces
			select $.faces[#{49..72}]
			select $.faces[#{1..24, 49..72}]
			modPanel.addModToSelection (Face_Extrude ()) ui:on
			$.modifiers[#Face_Extrude].amount = 1.2
			$.modifiers[#Face_Extrude].scale = 95
			convertto Volley_B editable_mesh
			subobjectLevel = 4
			select $.faces[#{25..48}]
			modPanel.addModToSelection (Face_Extrude ()) ui:on
			$.modifiers[#Face_Extrude].amount = 1.2
			$.modifiers[#Face_Extrude].scale = 95
			convertto Volley_B editable_mesh
			copy Volley_B isSelected:on name:"VolleyBall02"
			rotate $ (angleaxis 180 [1,0,0])
			attach Volley_B $VolleyBall02
			copy Volley_B isSelected:on name:"VolleyBall03"
			rotate $ (angleaxis 90 [0,0,1])
			rotate $ (angleaxis 90 [1,0,0])
			copy $VolleyBall03 isSelected:on name:"VolleyBall04"
			rotate $ (angleaxis 90 [0,1,0])
			rotate $ (angleaxis 90 [0,0,1])
			select $VolleyBall01
			attach $VolleyBall01 $VolleyBall03
			attach $VolleyBall01 $VolleyBall04
			addModifier $VolleyBall01 (meshsmooth iterations:1 subdivMethod:1)
			convertto $VolleyBall01 editable_mesh
			addModifier $VolleyBall01 (MultiRes Generate:off Vertex_Percentage:90)
			convertto $VolleyBall01 editable_mesh

		)
		
		on soccer pressed do

		(
			n5 =  Ngon radius:68.819 cornerRadius:0 nsides:5 circular:off scribe:0 pos:[0,0,0] isSelected:on name:"SoccerBall"
			rotate $ (angleaxis -90 [0,0,1])
			n6 = Ngon radius:100 cornerRadius:0 nsides:6 circular:off scribe:1 pos:[0,0,0] isSelected:on name:"NGon02"
			max modify mode
			n6.sides = 6
			move $ [0,137.71705,52.57667]
			rotate $ (angleaxis 37.377 [1,0,0])
			instance $ isSelected:on name:"NGon03"
			rotate $ (angleaxis -72 [0,0,1])
			move $ [130.92319,-95.15364,0]
			instance $ isSelected:on name:"NGon04"
			rotate $ (angleaxis -72 [0,0,1])
			move $ [-50.730431,-153.181084,0]
			instance $ isSelected:on name:"NGon05"
			rotate $ (angleaxis -72 [0,0,1])
			move $ [-161.886415,-0.28242543,0]
			instance $ isSelected:on name:"NGon06"
			rotate $ (angleaxis -72 [0,0,1])
			move $ [-49.207105,153.47215357,0]
			select $SoccerBall
			copy $ isSelected:on name:"NGon07"
			rotate $ (angleaxis 180 [0,0,1])
			move $ [-0.485645,-207.633309298,128.574]
			rotate $ (angleaxis -63.442 [1,0,0])
			copy $ isSelected:on name:"NGon08"
			rotate $ (angleaxis 72 [0,0,1])
			move $ [198.732381,143.42201,0]
			copy $ isSelected:on name:"NGon09"
			rotate $ (angleaxis 72 [0,0,1])
			move $ [-76.526825,232.815378,0]
			copy $ isSelected:on name:"NGon10"
			rotate $ (angleaxis 72 [0,0,1])
			move $ [-243.874,0,0]
			select $NGon08
			copy $ isSelected:on name:"NGon11"
			rotate $ (angleaxis -144 [0,0,1])
			move $ [-396.846183,0,0]
			select $NGon02
			copy $ isSelected:on name:"NGon12"
			move $ [0.223488,85.1829352,137.486]
			rotate $ (angleaxis 41.801 [1,0,0])
			copy $ isSelected:on name:"NGon13"
			rotate $ (angleaxis 72 [0,0,1])
			move $ [-211.848469,-153.96952,0]
			copy $ isSelected:on name:"NGon14"
			rotate $ (angleaxis -144 [0,0,1])
			move $ [422.47867,0,0]
			copy $ isSelected:on name:"NGon15"
			rotate $ (angleaxis -72 [0,0,1])
			move $ [-79.58057,-248.926963,0]
			copy $ isSelected:on name:"NGon16"
			rotate $ (angleaxis -72 [0,0,1])
			move $ [-263.10348,0,0]
			select objects
			convertto objects editable_mesh
			select $SoccerBall
			max modify mode
			attach $SoccerBall $NGon02
			attach $SoccerBall $NGon03
			attach $SoccerBall $NGon04
			attach $SoccerBall $NGon05
			attach $SoccerBall $NGon06
			attach $SoccerBall $NGon07
			attach $SoccerBall $NGon08
			attach $SoccerBall $NGon09
			attach $SoccerBall $NGon10
			attach $SoccerBall $NGon11
			attach $SoccerBall $NGon12
			attach $SoccerBall $NGon13
			attach $SoccerBall $NGon14
			attach $SoccerBall $NGon15
			attach $SoccerBall $NGon16
			select $SoccerBall
			modPanel.addModToSelection (Normalmodifier ())
			$.modifiers[#Normal].flip = on
			select $SoccerBall
			copy $ isSelected:on name:"flip01"
			rotate $ (angleaxis 180 [1,0,0])
			move $ [-0.656601,0,465.372782]
			select $flip01
			modPanel.addModToSelection (Normalmodifier ())
			$.modifiers[#Normal].flip = on
			select $SoccerBall
			attach $SoccerBall $flip01
			select $SoccerBall
			convertto $SoccerBall editable_mesh
			max modify mode
			subobjectLevel = 4
			select $SoccerBall.faces
			subobjectLevel = 0
			modPanel.addModToSelection (MeshSmooth iterations:2)
			modPanel.addModToSelection (Spherify ())
			modPanel.addModToSelection (Face_Extrude amount:3)
			modPanel.addModToSelection (meshsmooth ())
			$.modifiers[#MeshSmooth].subdivMethod = 1
			$.modifiers[#MeshSmooth].iterations = 1
			scale $ [0.15,0.15,0.15]
			convertto $SoccerBall editable_mesh

			)

		on G_Ball pressed do
			(
			Golf_ball = GeoSphere isSelected:on radius:60 segs: 6 name:"Golfball"
			convertTo Golf_ball mesh
			subobjectLevel = 4
			select Golf_ball.faces
			subobjectLevel = 2
			select Golf_ball.edges
			meshop.chamferEdges Golf_ball Golf_ball.edges 3
			subobjectLevel = 4
			modPanel.addModToSelection (Face_Extrude amount:0.4) ui:on
			modPanel.addModToSelection (meshsmooth iterations:1) ui:on
			convertTo Golf_ball mesh
			modPanel.addModToSelection (MultiRes ()) ui:on
			Golf_ball.modifiers[#MultiRes].Generate = off
			Golf_ball.modifiers[#MultiRes].Vertex_Percentage = 30
			convertTo Golf_ball mesh
            Golf_ball_m = Standard()
            Golf_ball_m.name = "Golt_ball_mat"
			Golf_ball_m.specularLevel = 50
			Golf_ball_m.glossiness = 58
			Golf_ball_m.Diffuse = color 248 248 248
			Golf_ball_m.ambient = color 255 255 255
			Golf_ball.material = Golf_ball_m

		)	

		on basket pressed do

		(
			basket_b = Sphere radius:25 smooth:on segs:32 chop:0 slice:off sliceFrom:0 sliceTo:0 isSelected:on mapCoords:on
			basket_b_m = Standard()
			basket_b_m.name = "Basketball_mat"
			basket_b.material = basket_b_m
			basket_b_m.bumpMap = Mix ()
			basket_b_m.bumpMap.map1 = Bitmaptexture fileName:"basket_bump.jpg"
			basket_b_m.bumpMap.map2 = Bitmaptexture fileName:"basket_bump_2.jpg"
			basket_b_m.bumpMap.map2.coords.U_Tiling = 5
			basket_b_m.bumpMap.map2.coords.V_Tiling = 5
			basket_b_m.bumpMap.map2.coords.Mapchannel = 2
			basket_b_m.bumpMap.mixAmount = 50
			basket_b_m.bumpMapAmount = -120
			basket_b_m.opacityMap = Mask ()
			basket_b_m.opacityMap.Mask = Bitmaptexture fileName:"basket_bump.jpg"
			basket_b_m.opacityMap.maskInverted = on
			basket_b_m.selfIllumAmount = 22
			basket_b_m.Diffuse = color 149 84 52
			basket_b_m.ambient = color 149 84 52
			showtexturemap basket_b.material basket_b.material.bumpMap on
			max views redraw
			addmodifier basket_b (Uvwmap name:"line")
			basket_b.modifiers[#line].axis = 1
			addmodifier basket_b (Uvwmap name:"noise")
			basket_b.modifiers[#noise].maptype = 2
			basket_b.modifiers[#noise].mapChannel = 2
			rotate basket_b (angleaxis -41.5 [0,0,1])
			rotate basket_b (angleaxis 18 [1,0,0])
			scale basket_b [1.82,1.82,1.82]
			max views redraw
		)
		on base_ball pressed do
			(
			base_b = Sphere radius:25 smooth:on segs:32 chop:0 isSelected:on name:"BaseBall"
			base_m = StandardMaterial()
			base_m.name = "Baseball_mat"
			select $baseball
			base_b.material = base_m
			base_m.diffuseMap = Mix ()
			base_m.diffuseMap.map1 = Bitmaptexture fileName:"base_diffuse.jpg"
			base_m.diffuseMap.map1.coords.U_Tiling = 0.94
			base_m.diffuseMap.map1.coords.V_Tiling = 0.94
			base_m.diffuseMap.map2 = Speckle ()
			base_m.diffuseMap.map2.color1 = color 255 249 188
			base_m.diffuseMap.map2.color2 = color 201 201 201
			base_m.diffuseMap.mixAmount = 20
			base_m.bumpMap = Mix ()
			base_m.bumpMap.map1 = Bitmaptexture fileName:"base_bump1.jpg"
			base_m.bumpMap.map2 = Bitmaptexture fileName:"base_bump2.jpg"
			base_m.bumpMap.map1.coords.U_Tiling = 0.94
			base_m.bumpMap.map1.coords.V_Tiling = 0.94
			base_m.bumpMap.map2.coords.U_Tiling = 0.94
			base_m.bumpMap.map2.coords.V_Tiling = 0.96
			base_m.bumpMap.mixAmount = 50
			base_m.bumpMapAmount = 30
			showtexturemap base_b.material base_b.material.diffuseMap on
			)
)

addRollout params balls_win


Rollout params "About and Help"
	(

	Group "Help"

		(
		button help_k "Korean" width:60 across:2
		button help_e "English" width:60
		)

	Group "About "
	
		(
		Label a1 "Ball's Maker v1.02"
		button Tj_Logo ""images:#("tjoon.gif",undefined,1,1,1,1,1) align:#center tooltip:"http://teamjoon.com" width:100 height:20
		Label a2 "by Kim Kyung-Sin"
		button tdp_Logo ""images:#("satdp.jpg",undefined,1,1,1,1,1) align:#center tooltip:"http://tdp.nu" width:152 height:20
		Label a3 "Update : http://www.tdp.nu"
		Label a5 "Update Day : 2001.06.22"
		)

		on Tj_Logo pressed do
			(
			rollout tjoon_web "Web page" 
				( 
				activeXControl ax "www.teamjoon.com" height:768 width:1024 align:#center
				) 
				
				tjoon_web_floater = newRolloutFloater "Teamjoon Home page" 1024 768
				
				addRollout tjoon_web tjoon_web_floater
				
				registerViewWindow tjoon_web_floater 
				
				showProperties tjoon_web.ax
				)

		on tdp_Logo pressed do
			(
			rollout tdp_web "Web page" 
				( 
				activeXControl ax "tdp.nu/index.shtml" height:768 width:1024 align:#center
				) 
				tdp_web_floater = newRolloutFloater "TDP Home page" 1024 768
				
				addRollout tdp_web tdp_web_floater
				
				registerViewWindow tdp_web_floater 
				
				showProperties tdp_web.ax
				)
	
		on help_k pressed do
			messagebox ("     ϴ.") beep:no title:"Korean Help"
		on help_e pressed do
			messagebox ("Push the Ball Button!!") beep:no title:"English Help"
		)

addRollout params balls_win