macroScript Auto_Frame_Face_Dialog category:"Sheephao Tools" buttontext:"Auto Frame Face Dialog" tooltip:"Auto Frame Face Dialog" Icon:#("Sheephao_Tools",2)

(
	rollout frmmain "λֱ" width:144 height:152
	(
		button btn1 "" pos:[9,9] width:130 height:19
		GroupBox grp1 "ѹ" pos:[9,52] width:130 height:92
		checkbox ChkExtrude "" pos:[18,67] width:88 height:15 checked:true
		radiobuttons rdo1 "" pos:[16,84] width:79 height:32 labels:#("ͼ", "ָ") columns:1
		spinner ValueOS "ƫ:" pos:[18,34] width:120 height:16 range:[-99999,99999,40] scale:1
		spinner ValueExtrude "" pos:[16,120] width:120 height:16 enabled:false range:[-99999,99999,0] scale:1
		
		local ini_file = ((getDir #plugcfg) + "\\Sheephao_Tools.ini")
		
		on frmmain open do
		(
			local offset_value
			local extrude_enabled
			local extrude_type
			local extrude_value
			
			offset_value=getinisetting ini_file "AutoFrameFace" "Offset_Value"
			if offset_value=="" then setinisetting ini_file "AutoFrameFace" "Offset_Value" "40" else ValueOS.value=(offset_value as float)
			
			extrude_enabled=getinisetting ini_file "AutoFrameFace" "Extrude_Boolean"
			case extrude_enabled of
			(
				"":
				(
					setinisetting ini_file  "AutoFrameFace" "Extrude_Boolean" "true"
				)
				"True":
				(
					ChkExtrude.checked=true
				)
				"False":
				(
					ChkExtrude.checked=false
					rdo1.enabled=false
					ValueExtrude.enabled=false
				)
			)
			extrude_type=getinisetting ini_file "AutoFrameFace" "Extrude_Type"
			case extrude_type of
			(
				"":
				(
					setinisetting ini_file  "AutoFrameFace" "Extrude_Type" "Viewport"
				)
				"Viewpot":
				(
					rdo1.state=1
				)
				"Specify":
				(
					rdo1.state=2
					if ChkExtrude.checked==true then ValueExtrude.enabled=true
				)
			)
			extrude_value=getinisetting ini_file "AutoFrameFace" "Specify_Extrude_Value"
			if extrude_value=="" then setinisetting ini_file  "AutoFrameFace" "Specify_Extrude_Value" "0"	 else ValueExtrude.value=(extrude_value as float)
		)
		
		on btn1 pressed do
		(
				local pot1  --Line start point
				local pot2  --Line end point
				local potM  --The middle of the line
				local pot3  --Extrude value point
				local Dist  --Extrude value
				local ValOffset  --Offset value
				
				pot1=pickpoint snap:#3d
				if pot1==#escape or pot1==#rightClick then return ok
				pot2=pickpoint snap:#3d rubberband:pot1
				if pot2==#escape or pot2==#rightClick then return ok
				
				case of 
					(
						(chkextrude.checked==true and rdo1.state==1):
							(
								pot3=pickpoint snap:#3d rubberband:pot2
								if pot3==#escape or pot3==#rightClick then return ok
								dist=distance pot2 pot3
							)
						(chkextrude.checked==true and rdo1.state==2):dist=valueextrude.value
						(chkextrude.checked==false):dist=0
					)
				
				--Create new line
				potM=(pot1+pot2)/2
				newline = splineShape pos:potM isSelected:on
				addnewspline newline
				addknot newline 1 #corner  #curve pot1
				addknot newline 1 #corner  #curve pot2
				updateshape newline
				
				--Set offset
				ValOffset=ValueOS.Value
				if valoffset!=0 then 
					(
						local p1
						local p2
						local p3
						local p4
						local mat1
						local Llength
						
						p1=getKnotPoint $ 1 1
						p2=getKnotPoint $ 1 2
						Llength=distance p1 p2
						p3=p2-p1
						mat1=rotateZMatrix -90
						p4=p3*mat1*(valoffset/Llength)
						move $ p4
					)
				
				--Set Etrude
				if dist!=0 then
					(
						modPanel.addModToSelection (Extrude ()) ui:on
						$.modifiers[#Extrude].amount = dist
					)
			)
		on ChkExtrude changed state do
		(
			if ChkExtrude.checked==false then
					(
						rdo1.enabled=false
						ValueExtrude.enabled=false
		                  setinisetting ini_file "AutoFrameFace" "Extrude_Boolean" "False"
					)
					else
					(
						rdo1.enabled=true
		                  setinisetting ini_file "AutoFrameFace" "Extrude_Boolean" "True"
						if rdo1.state==2 then valueextrude.enabled=true else valueextrude.enabled=false	
					)
		)
		on rdo1 changed stat do
		(
			if rdo1.state==1 then
				(
		              valueextrude.enabled=false
		              setinisetting ini_file "AutoFrameFace" "Extrude_Type" "Viewport" 
		          )
			else
				(
		             valueextrude.enabled=true
		             setinisetting ini_file "AutoFrameFace" "Extrude_Type" "Specify" 
		         )
		)
		on ValueOS changed val do
			setinisetting ini_file "AutoFrameFace" "Offset_Value" (ValueOS.value as string)
		on ValueExtrude changed val do
			setinisetting ini_file "AutoFrameFace" "Specify_Extrude_Value" (valueExtrude.value as string)
	)

	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)
