macroScript Auto_Perron category:"Sheephao Tools" buttontext:"̨" tooltip:"̨1" Icon:#("Sheephao_Tools",8)
(
	local pot1	--stair point 1
	local pot2	--stair point 2
	local pot3	--stair point 3
	local pot4	--stair point 4
	local step_amount	--amount of steps
	local v1	--unit vector from pot1 to pot4
	local v2	--unit vector from pot2 to pot3
	local step_height	--height of step
	local perron	--node of perron
	
	fn CreatePerron=
	(
		print "ʰȡ1"
		pot1=pickpoint snap:#3d
		if pot1==#escape or pot1==#rightClick then return ok
		print "ʰȡ2"
		pot2=pickpoint snap:#3d rubberband:pot1
		if pot2==#escape or pot2==#rightClick then return ok
		print "ʰȡ3"
		pot3=pickpoint snap:#3d rubberband:pot2
		if pot3==#escape or pot3==#rightClick then return ok
		print "ʰȡ4"
		pot4=pickpoint snap:#3d rubberband:pot3
		if pot4==#escape or pot4==#rightClick then return ok
			
		pot2.z=pot1.z
		pot3.z=pot4.z
		
		step_amount=abs(pot1.z-pot4.z)/150
		case of
		(
			((step_amount-floor(step_amount))>=0.5):(step_amount=ceil step_amount)
			((step_amount-floor(step_amount))<0.5):(step_amount=floor step_amount)
		)
		if step_amount<2 then return ok
		step_height=(pot4.z-pot1.z)/step_amount
		
		v1=(pot4-pot1)/(step_amount-1)
		v1.z=0
		v2=(pot3-pot2)/(step_amount-1)
		v2.z=0
		
		p1=copy pot1
		p2=copy pot2
		
		perron=mesh numverts:0 numfaces:0 name:(uniquename "Perron")
		perron.pivot=(pot1+pot2)/2
		perron=convertTo perron (Editable_Poly)
		
		p3=p2+[0,0,step_height]
		p4=p1+[0,0,step_height]
		pi1=polyop.createvert perron p1
		pi2=polyop.createvert perron p2
		pi3=polyop.createvert perron p3
		pi4=polyop.createvert perron p4
		polyop.createpolygon perron #(pi1,pi2,pi3,pi4)
		for i in 2 to step_amount do
		(
			--p1=p4
			--p2=p3
			p4=p4+v1
			p3=p3+v2
			pi1=pi4
			pi2=pi3
			pi3=polyop.createvert perron p3
			pi4=polyop.createvert perron p4
			polyop.createpolygon perron #(pi1,pi2,pi3,pi4)
			p3=p3+([0,0,step_height] as point3)
			p4=p4+([0,0,step_height] as point3)
			--p1=p4
			--p2=p3
			pi1=pi4
			pi2=pi3
			pi3=polyop.createvert perron p3
			pi4=polyop.createvert perron p4
			polyop.createpolygon perron #(pi1,pi2,pi3,pi4)
		)
		
	)
	
	CreatePerron()
)