macroScript Auto_Vertex category:"Sheephao Tools" buttontext:"Զ" tooltip:"SplinePolyĵԶ" icon:#("Sheephao_Tools",11)
(
	include "Sheephao_Functions_Array_Arithmetic.ms"
	
	fn Poly_operation=
	(
		local sel_edges_ary=#()
		local sel_edges_ary2=#()
		local operate_verts_ary=#()
		local operate_verts_ary2=#()
		local end_verts_ary=#()
		local total_xy_length=0.0
		local total_z
		local p1=[0,0],p2=[0,0]
		
		sel_edges_ary=polyop.getedgeselection $
		if sel_edges_ary.count<2 then return ok
		for e in sel_edges_ary do
		(
			temp_ary=polyop.getedgeverts $ e
			p1.x=(polyop.getvert $ temp_ary[1]).x
			p1.y=(polyop.getvert $ temp_ary[1]).y
			p2.x=(polyop.getvert $ temp_ary[2]).x
			p2.y=(polyop.getvert $ temp_ary[2]).y
			xy=distance p1 p2
			total_xy_length=total_xy_length+xy
		)--end for
		operate_verts_ary=polyop.getvertsusingedge $ sel_edges_ary
		for e in operate_verts_ary do
		(
			temp_ary=aryi (polyop.getedgesusingvert $ e) sel_edges_ary
			if temp_ary.count==1 then append end_verts_ary e
			if temp_ary.count>2 then return ok
		)--end for
		if end_verts_ary.count!=2 then return ok
		total_z=(polyop.getvert $ end_verts_ary[2]).z-(polyop.getvert $ end_verts_ary[1]).z
		
		sel_edges_ary2=sel_edges_ary2+sel_edges_ary
		operate_verts_ary2=arys operate_verts_ary end_verts_ary
		current_vert=end_verts_ary[1]
		j=operate_verts_ary2.count
		for i in 1 to j do
		(
			temp_edge=aryi (polyop.getedgesusingvert $ current_vert) sel_edges_ary2
			temp_vert=aryi (polyop.getedgeverts $ temp_edge[1]) operate_verts_ary2
			p1.x=(polyop.getvert $ current_vert).x
			p1.y=(polyop.getvert $ current_vert).y
			p2.x=(polyop.getvert $ temp_vert[1]).x
			p2.y=(polyop.getvert $ temp_vert[1]).y
			xy_dist=distance p1 p2
			x=(polyop.getvert $ temp_vert[1]).x
			y=(polyop.getvert $ temp_vert[1]).y
			z=total_z*(xy_dist/total_xy_length)+(polyop.getvert $ current_vert).z
			current_vert=temp_vert[1]
			polyop.setvert $ temp_vert [x,y,z]
			sel_edges_ary2=arys sel_edges_ary2 temp_edge
			operate_verts_ary2=arys operate_verts_ary2 temp_vert
		)--end for
	)--end function
	
	fn shape_operation=
	(
		for i in 1 to (numsplines $) do
		(
			--knot_array=#()
			knot_array=getKnotSelection $ i
			if knot_array.count==2 then
			(
				local p1=[0,0]
				local p2=[0,0]
				z1=(getknotpoint $ i knot_array[1]).z
				z2=(getknotpoint $ i knot_array[2]).z
				dist_z=z2-z1
				dist_array=#()
				dist_xy=0.0
				for j in knot_array[1] to (knot_array[2]-1) do
				(	
					p1.x=(getknotpoint $ i j).x
					p1.y=(getknotpoint $ i j).y
					p2.x=(getknotpoint $ i j+1).x
					p2.y=(getknotpoint $ i j+1).y
					append dist_array (distance p1 p2)
					dist_xy=dist_xy+(distance p1 p2)
				)--end for
				k=1
				z3=z1
				for j in knot_array[1]+1 to knot_array[2]-1 do
				(
					z3=z3+dist_z*(dist_array[k]/dist_xy)
					k=k+1
					setknotpoint $ i j [(getknotpoint $ i j).x,(getknotpoint $ i j).y,z3]
				)--end for
			)--end if	
		)--end for
		updateshape $
	)
	
	case (classof $) of
	(
		Editable_Poly:Poly_operation()
		SplineShape:shape_operation()
		line:shape_operation()
	)
)--end script