macroScript Auto_Window_Type_01_Dialog category:"Sheephao Tools" buttontext:"Auto Window Type 1 Dialog" tooltip:"Auto Window Type 1 Dialog" Icon:#("Sheephao_Tools",4)
(
	include "Sheephao_Tools_Auto_Window_Public_Functions.ms"
	rollout frmmain "͹" width:160 height:216
	(
		GroupBox grp_offset "ƫ" pos:[8,8] width:144 height:72 enabled:true
		spinner spn_Glass "" pos:[24,24] width:96 height:16 range:[0,1000,350] scale:50
		spinner spn_frame "" pos:[24,40] width:96 height:16 range:[0,100,40] scale:10
		spinner spn_board "̨" pos:[24,56] width:96 height:16 range:[0,1000,100] type:#float scale:50
		GroupBox grp_height "߶" pos:[8,80] width:144 height:104
		checkbox chk_frame "" pos:[128,40] width:16 height:16 checked:true
		checkbox chk_board "" pos:[128,56] width:16 height:16 checked:true
		radiobuttons rdo_window "" pos:[24,112] width:51 height:32 enabled:true labels:#("ͼ", "ָ") columns:1
		spinner spn_height_window "" pos:[80,128] width:56 height:16 enabled:false range:[0,999999,2000] type:#float scale:50
		spinner spn_height_board "̨" pos:[24,160] width:120 height:16 range:[0,10000,100] type:#float scale:50
		checkbox chk_glass "" pos:[128,24] width:16 height:16 checked:true
		button btn_create "" pos:[8,192] width:144 height:16 toolTip:""
		GroupBox grp7 "" pos:[16,96] width:128 height:56
		
		local ini_file = ((getDir #plugcfg) + "\\Sheephao_Tools.ini")
		
		on frmmain open do
		(
			local glass_enabled
			local frame_enabled
			local board_enabled
			local glass_offset
			local frame_offset
			local board_offset
			local window_height_type
			local window_height
			local board_height
			
			--read setting from ini file
			glass_enabled=getIniSetting ini_file "Auto_Window_Type_1" "Glass_Enabled"
			case of 
			(
				(glass_enabled==""):
				(
					setinisetting ini_file "Auto_Window_Type_1" "Glass_Enabled" "True"
					glass_enabled="True"
				)
				(glass_enabled=="True"):
				(
					chk_glass.checked=true 
		
					spn_glass.enabled=true
				)
				(glass_enabled=="False"):
				(
					chk_glass.checked=false
					spn_glass.enabled=false
				)
			)
			
			frame_enabled=getinisetting ini_file "Auto_Window_Type_1" "Frame_Enabled"
			case of
			(
				(frame_enabled==""):
				(
					setinisetting ini_file "Auto_Window_Type_1" "Frame_Enabled" "True"
					frame_enabled="True"
				)
				(frame_enabled=="True"):
				(
					chk_frame.checked=true
					spn_frame.enabled=true
				)
				(frame_enabled=="False"):
				(
					chk_frame.checked=false
					spn_frame.enabled=false
				)
			)
			
			board_enabled=getinisetting ini_file "Auto_Window_Type_1" "Board_Enabled"
			case of
			(
				(board_enabled==""):
				(
					setinisetting ini_file "Auto_Window_Type_1" "Board_Enabled" "True"
					board_enabled="True"
				)
				(board_enabled=="True"):
				(
					chk_board.checked=true
					spn_board.enabled=true
				)
				(board_enabled=="False"):
				(
					chk_board.checked=false
					spn_board.enabled=false
				)
			)
			
			window_height_type=getinisetting ini_file "Auto_Window_Type_1" "Window_Height_Type"
			case of
			(
				(window_height_type==""):
				(
					setinisetting ini_file "Auto_Window_Type_1" "Window_Height_Type" "Viewport"
					window_height_type="Viewport"
				)
				(window_height_type=="Viewport"):
				(
					rdo_window.state=1
					spn_height_window.enabled=false
				)
				(window_height_type=="Specify"):
				(
					rdo_window.state=2
					spn_height_window.enabled=true
				)
			)
			
			glass_offset=getinisetting ini_file "Auto_Window_Type_1" "Glass_offset"
			if glass_offset=="" then
			(
				setinisetting ini_file "Auto_Window_Type_1" "Glass_offset" "350"
				glass_offset="350"
			)
			spn_glass.value=glass_offset as float
			
			frame_offset=getinisetting ini_file "Auto_Window_Type_1" "Frame_offset"
			if frame_offset=="" then
			(
				setinisetting ini_file "Auto_Window_Type_1" "Frame_offset" "40"
				frame_offset="40"
			)
			spn_frame.value=frame_offset as float
			
			board_offset=getinisetting ini_file "Auto_Window_Type_1" "Board_offset"
			if board_offset=="" then
			(
				setinisetting ini_file "Auto_Window_Type_1" "Board_offset" "40"
				board_offset="40"
			)
			spn_board.value=board_offset as float
			
			window_height=getinisetting ini_file "Auto_Window_Type_1" "Window_Height"
			if window_height=="" then
			(
				setinisetting ini_file "Auto_Window_Type_1" "Window_Height" "2000"
				window_height="2000"
			)
			spn_height_window.value=window_height as float
			
			board_height=getinisetting ini_file "Auto_Window_Type_1" "Board_Height"
			if board_height=="" then
			(
				setinisetting ini_file "Auto_Window_Type_1" "Board_Height" "100"
				board_height="100"
			)
			spn_height_board.value=board_height as float
		)
		on spn_Glass changed val do
		(
			setinisetting ini_file "Auto_Window_Type_1" "Glass_Offset" (spn_glass.value as string)
		)
		on spn_frame changed val do
		(
			setinisetting ini_file "Auto_Window_Type_1" "Frame_Offset" (spn_Frame.value as string)
		)
		on spn_board changed val do
		(
			setinisetting ini_file "Auto_Window_Type_1" "Board_Offset" (spn_Board.value as string)
		)
		on chk_frame changed state do
		(
			if chk_frame.checked==true then 
			(
				spn_frame.enabled=true 
				setinisetting ini_file "Auto_Window_Type_1" "Frame_Enabled" "True"
			)
			else 
			(
				spn_frame.enabled=false
				setinisetting ini_file "Auto_Window_Type_1" "Frame_Enabled" "False"
			)
		)
		on chk_board changed state do
		(
			if chk_board.checked==true then 
			(
				spn_board.enabled=true 
				setinisetting ini_file "Auto_Window_Type_1" "Board_Enabled" "True"
			)
			else 
			(
				spn_board.enabled=false
				setinisetting ini_file "Auto_Window_Type_1" "Board_Enabled" "False"
			)
		)
		on rdo_window changed stat do
		(
			if rdo_window.state==1 then
			(
				spn_height_window.enabled=false
				setinisetting ini_file "Auto_Window_Type_1" "Window_Height_Type" "Viewport"
			)
			else
			(
				spn_height_window.enabled=true
				setinisetting ini_file "Auto_Window_Type_1" "Window_Height_Type" "Specify"
			)
		)
		on spn_height_window changed val do
		(
			setinisetting ini_file "Auto_Window_Type_1" "Window_Height" (spn_height_window.value as string)
		)
		on spn_height_board changed val do
		(
			setinisetting ini_file "Auto_Window_Type_1" "Board_Height" (spn_height_board.value as string)
		)
		on chk_glass changed state do
		(
			if chk_glass.checked==true then 
			(
				spn_glass.enabled=true
				setinisetting ini_file "Auto_Window_Type_1" "Glass_Enabled" "True"
			)
			else 
			(
				spn_glass.enabled=false
				setinisetting ini_file "Auto_Window_Type_1" "Glass_Enabled" "False"
			)
		)
		on btn_create pressed do
		(
			Auto_window_type_01_operation()
		)
	)	
	
	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)