macroScript PTP_Clone category:"Sheephao Tools" buttontext:"PTP Clone" tooltip:"PTP Clone" icon:#("Sheephao_Tools",5)
(
	local base_point
	local target_point
	local offset_vector_factor
	local offset_vector
	local org_node_array=#()
	local tag_node_array=#()
	local new_node_amount
	local amount_buffer
	local alt_key
	local shift_key
	--local amount_rollout
	
	rollout amount_rollout "" width:160 height:64
	(
		button btn_ok "ȷ" pos:[8,32] width:64 height:24 
		spinner spn_amount "" pos:[16,8] width:136 height:16 range:[0,10000,2] type:#integer scale:1
		button btn_cancel "ȡ" pos:[88,32] width:64 height:24
		
		on amount_rollout open do
		(
			spn_amount.value=amount_buffer
		)
		
		on btn_ok pressed do
		( 
			new_node_amount=spn_amount.value
			amount_buffer=spn_amount.value
			DestroyDialog amount_rollout
		)--end on
		
		on btn_cancel pressed do
		( 
			new_node_amount=0
			DestroyDialog amount_rollout
		)--end on
	)--end rollout
	
	if selection.count>0 then
	(	
		org_node_array=selection as array
		new_node_amount=2
		amount_buffer=2
		base_point=pickpoint snap:#3d
		if base_point!=#escape and base_point!=#rightclick then
		(
			while target_point!=ok do
			(	
				target_point=pickpoint snap:#3d rubberband:base_point
				alt_key=keyboard.altPressed
				shift_key=keyboard.shiftPressed
				if target_point==#escape or target_point==#rightclick then
				(
					target_point=ok
				)
				else
				(	
					offset_vector_factor=target_point-base_point
					if shift_key==true then
					(
						createdialog amount_rollout modal:true
					)
					else
					(
						new_node_amount=1
					)--end if
					for a in 1 to new_node_amount do
					(
						tag_node_array=#()
						offset_vector=offset_vector_factor*a
						for e in org_node_array do
						(
							if (isgrouphead e)==true then new_node=copy e else
							(
								if alt_key==true then new_node=copy e else new_node=instance e
							)--end if
							new_node.wirecolor=e.wirecolor
							move new_node offset_vector
							append tag_node_array new_node
						)--end for
						for i in 1 to tag_node_array.count do
						(	
							parent_index=finditem org_node_array org_node_array[i].parent
							if parent_index!=0 then tag_node_array[i].parent=tag_node_array[parent_index] else tag_node_array[i].parent=org_node_array[i].parent
							if (isgrouphead org_node_array[i])==true then setgrouphead tag_node_array[i] true
							if (isgroupmember org_node_array[i])==true then setgroupmember tag_node_array[i] true
						)--end for
					)--end for
				)--end if
			)--end while
		)--end if
	)--end if
)