macroScript Quick_Insert category:"Sheephao Tools" buttontext:"QI" tooltip:"Quick Insert" icon:#("Sheephao_Tools",13)
(
	--local base_point,target_point
	local org_obj,target_obj
	local axis
	local offset
	local check_snap
	local clone_type
	local check_per	--
	
	local main_operation

	rollout frmmain "Quick insert" width:184 height:120
	(
		pickbutton btn_pick "ʰȡԴ" pos:[8,8] width:168 height:16
		radiobuttons rdo_axis "" pos:[8,32] width:62 height:16 labels:#("x", "y") columns:2
		spinner spn_offset "ƫ:" pos:[80,32] width:96 height:16 range:[-1e+008,1e+008,0] type:#float scale:50
		radiobuttons rdo_clnoe_type "" pos:[8,56] width:79 height:32 labels:#("Copy", "Instance") default:2 columns:1
		checkbox chk_snap "45㲶׽" pos:[96,56] width:80 height:16 checked:true
		checkbox chk_per "" pos:[96,72] width:80 height:16 checked:true
		checkbutton ckb_insert "볡" pos:[8,96] width:168 height:16
		
		on frmmain open do
		(
			org_obj=undefined
		)
		on btn_pick picked obj do
		(
			btn_pick.caption=obj.name
			org_obj=obj
		)
		on chk_snap changed state do
		(
			case of
			(
				(chk_snap.checked==true):(chk_per.enabled=true)
				(chk_snap.checked==false):(chk_per.enabled=false)
			)--end case
		)
		on ckb_insert changed state do
		(
			if ckb_insert.state=on and org_obj!=undefined then 
			(
				err=false
				try org_obj.name catch(err=true)
				if not err then
				(	
					case rdo_axis.state of
					(
						1:(axis="x")
						2:(axis="y")
						--3:(axis="z")
					)--end case
					case rdo_clnoe_type.state of
					(
						1:(clone_type=#copy)
						2:(clone_type=#instance)
					)--end case
					offset=spn_offset.value
					check_snap=chk_snap.checked
					if chk_snap.checked then check_per=chk_per.checked else check_per=false
					main_operation()
				)
				else 
				(
					ckb_insert.state=off
					btn_pick.caption="ʰȡԴ"
					org_obj=undefined
				)
			)
			else ckb_insert.state=off
		)
	)	
	
	
	
	--Ჶ׽
	fn snap_axis b_p t_p=
	(
		x1=t_p.x-b_p.x
		y1=t_p.y-b_p.y
		x2=abs x1
		y2=abs y1
		if x1==0 then return t_p
		else
		(
			case of
			(
				(y2/x2>0.57735 and y2/x2<1.73205):
				(
					r=(x2+y2)/2
					if x1<0 then r1=-r else r1=r
					if y1<0 then r2=-r else r2=r
					return (b_p+[r1,r2,0])
				)
				(y2/x2<=0.57735):(return [t_p.x,b_p.y,t_p.z])
				(y2/x2>=1.73205):(return [b_p.x,t_p.y,t_p.z])
			)--end case
		)--end if
	)
	
	fn mouse_moving c_point l_point=
	(	
		base_p=l_point
		if check_snap then target_p=snap_axis l_point c_point else target_p=c_point
		target_p.z=base_p.z
		offset_v=normalize (target_p-base_p)
		if keyboard.controlPressed then offset_v=-offset_v
		z=[0,0,1]
		case axis of
		(
			"x":(if not keyboard.shiftPressed then (x=offset_v ; y=cross z x) else (y=offset_v ; x=cross y z))
			"y":(if not keyboard.shiftPressed then (y=offset_v ; x=cross y z)	 else (x=offset_v ; y=cross z x))
		)--end case
		if check_per and abs(abs(offset_v.x)-abs(offset_v.y))<0.0001 then (os=offset*(sqrt 2) ; print "1")else (os=offset ; print "2")
		base_p+=offset_v*os
		m=matrix3 x y z base_p
		target_obj.transform=m
	)--end function
	
	fn main_operation=
	(	
		eof_operation=false
		while eof_operation==false do
		( 
			base_point=pickpoint snap:#3d
			if base_point==#escape or base_point==#rightclick then
			(
				eof_operation=true
			)
			else
			(
				maxops.clonenodes org_obj clonetype:clone_type newnodes:&new_obj
				target_obj=new_obj[1]
				target_point=pickpoint snap:#3d rubberband:base_point mousemovecallback:#(mouse_moving,base_point)
				if target_point==#escape or target_point==#rightclick then
				(
					delete target_obj
				)
			)--end if
		)--end while
		frmmain.ckb_insert.state=off
	)--end function
	
	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)--end script