macroScript Vertex_Auto_Remove category:"Sheephao Tools" buttontext:"Ƴ" tooltip:"Ƴ" Icon:#("Sheephao_Tools",10)
(

	
	--user defined function,check vertexs for poly object
	fn verts_checker three_verts_array poly_object=
	(
		local p1,p2,p3
		local d1,d2,d3
		local v1,v2
		
		p1=polyop.getvert poly_object three_verts_array[1]
		p2=polyop.getvert poly_object three_verts_array[2]
		p3=polyop.getvert poly_object three_verts_array[3]
		d1=distance p1 p2
		d2=distance p2 p3
		d3=distance p1 p3
		if d1<0.0001 or d2<0.0001 or d3<0.0001 then return true else false
		v1=normalize (p2-p1)
		v2=normalize (p3-p1)
		if length(v1-v2)<0.001 or length(v1+v2)<0.001 then return true else false
	)
	--function end
	
	--main poly operation function
	fn Poly_operation=
	(	
		local sel_open_edges_array=#()
		local op_verts_array=#()
		local remove_verts_array=#()--verts need to be removed array 	
		--get selected open edges,save as sel_edges_array
		open_edges_array=polyop.getopenedges $
		if open_edges_array.count==0 then return ok
		sel_edges_array=polyop.getedgeselection $
		if sel_edges_array.count==0 then return ok
		for e in sel_edges_array do
		(
			if (finditem open_edges_array e)!=0 then
			(
				append sel_open_edges_array e
			)
		)
		if sel_open_edges_array.count==0 then return ok
		--end
		--get verts on selected edges,save as op_verts_array
		for e in sel_edges_array do
		(
			verts_temp=polyop.getedgeverts $ e
			if (finditem op_verts_array verts_temp[1])==0 then append op_verts_array verts_temp[1]
			if (finditem op_verts_array verts_temp[2])==0 then append op_verts_array verts_temp[2]
		)
		--print "op_verts_array"
		--print op_verts_array
		--end
		--create remove_verts_array
		for vert_temp in op_verts_array do 
		(
			vert_edges_array=polyop.getedgesusingvert $ vert_temp
			tow_edges=#()
			for edge_temp in vert_edges_array do
			(
				if (finditem sel_open_edges_array edge_temp)!=0 do append tow_edges edge_temp
			)
			--print "edges-------------"
			--print tow_edges
			if tow_edges.count==2 then
			(
				three_verts=#()
				join three_verts (polyop.getedgeverts $ tow_edges[1])
				if (finditem three_verts (polyop.getedgeverts $ tow_edges[2])[1])==0 then append three_verts (polyop.getedgeverts $ tow_edges[2])[1]
				if (finditem three_verts (polyop.getedgeverts $ tow_edges[2])[2])==0 then append three_verts (polyop.getedgeverts $ tow_edges[2])[2]
				--print "verts----------------"
				--print three_verts
				if three_verts.count==3 then
				(
					if (verts_checker three_verts $)==true then append remove_verts_array vert_temp
				)
			)
		)
		--print "remove_verts_array:"
		--print remove_verts_array
		if remove_verts_array.count==0 then return ok
		--end
		--remove verts
		sol_temp=subobjectLevel 
		subobjectLevel = 1
		polyop.setvertselection $ remove_verts_array
		before_amount=remove_verts_array.count
		$.EditablePoly.Remove()
		after_amount=((polyop.getvertselection $) as array).count
		subobjectLevel = sol_temp
		print ("ɡƳ"+((before_amount-after_amount)as string)+"㡣"+"Operation complete."+((before_amount-after_amount)as string)+" vertex(s) has(have) been removed.")
		--end
	)
	--function end
	--main shape operation function
	fn shape_operation=
	(	
		local sel_splines_array=#()
		local sel_segments_array=#()
		local remove_knots_array=#()
		local k1,k2,k3
		local v1,v2
		
		befroe_knots=numknots $
		sel_splines_array=getsplineselection $
		for spi in 1 to (numSplines $) do
		(	
			--create knots to be removed array
			remove_knots_array=#()
			if (finditem sel_splines_array spi)!=0 then
			(	
				sel_segments_array=#()
				for i in 1 to (numSegments $ spi) do append sel_segments_array i
			)
			else
			(
				sel_segments_array=getsegselection $ spi
			)
			if sel_segments_array.count>1 then
			(
				for segi in 1 to sel_segments_array.count-1 do
				(
					if sel_segments_array[segi]+1==sel_segments_array[segi+1] then
					(	
						k1=getknotpoint $ spi sel_segments_array[segi]
						k2=getknotpoint $ spi (sel_segments_array[segi]+1)
						if (sel_segments_array[segi]+2)<=(numknots $ spi) then k3=getknotpoint $ spi (sel_segments_array[segi]+2) else k3=getknotpoint $ spi 1
						if ((distance k2 k1)<0.001) or ((distance k3 k2)<0.001) then
						(
							append remove_knots_array (sel_segments_array[segi]+1)
						)
						else
						(
							v1=normalize (k2-k1)
							v2=normalize (k3-k2)
							if length(v1-v2)<0.001 then append remove_knots_array (sel_segments_array[segi]+1)
						)
					)
				)
				if (sel_segments_array[sel_segments_array.count]==numknots $ spi) and (sel_segments_array[1]==1) then
				(
					k1=getknotpoint $ spi (numknots $ spi)
					k2=getknotpoint $ spi 1
					k3=getknotpoint $ spi 2
					v1=normalize (k2-k1)
					v2=normalize (k3-k2)
					if length(v1-v2)<0.001 then append remove_knots_array 1
				)
			)
			--end
			--set knots selection
			setknotselection $ spi remove_knots_array
			--end
		)
		--remove knots
		sol_temp=subobjectLevel
		subobjectLevel = 1
		modPanel.setCurrentObject $.baseObject
		max delete
		subobjectLevel = sol_temp
		modPanel.setCurrentObject $.baseObject		
		--end
		after_knots=numknots $
		print ("ɡƳ"+((befroe_knots-after_knots) as string)+"ڵ㡣"+"Operation complete."+((befroe_knots-after_knots) as string)+" knot(s) has(have) been removed")
	)
	--function end
	--call main operation function
	case (classof $) of
	(
		Editable_Poly:Poly_operation()
		SplineShape:shape_operation()
		line:shape_operation()
	)
	--end
)