macroScript Clone_by_verts category:"Sheephao Tools" buttontext:"CBV" tooltip:"Clone by verts" --Icon:#("Sheephao_Tools",6)
(
	local org_obj
	
	local main_operation
	
	rollout frmmain "Clone by verts" width:152 height:72
	(
		pickButton btn_org_obj "Pick object" pos:[8,8] width:136 height:24
		button btn_operate "Operate" pos:[8,40] width:136 height:24
		
		on btn_org_obj picked obj do
		(
			org_obj=obj
			btn_org_obj.caption=obj.name	
		)
		on btn_operate pressed do
		(
			try main_operation() catch( btn_org_obj.caption="Pick object" )
		)
	)
	
	fn main_operation=
	(
		for e in selection do
		(
			if iskindof e editable_poly then
			(
				num_verts=polyop.getnumverts e
				for v in 1 to num_verts do
				(
					faces=polyop.getfacesusingvert e v as array
					v_normal=[0,0,0]
					for f in faces do v_normal+=polyop.getfacenormal e f
					z=normalize v_normal
					if z.x==0 and z.y==0 then 
					(
						x=[1,0,0]
						y=[0,1,0]
					)
					else
					(
						z2=copy z
						z2.z=0
						x=normalize (z2*(rotateZMatrix 90))
						y= cross z x
					)
					m=(matrix3 x y z (polyop.getvert e v))
					maxops.clonenodes org_obj clonetype:#instance newNodes:&new_obj
					new_obj[1].transform=m
					--update new_obj[1]
				)--end for
			)--end if
		)--end for
	)--end function
	
	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)