macroScript Historic_Bilding_Corner_Type05 category:"kevin" buttontext:"ݼν05" tooltip:"ݼν05" Icon:#("Sheep_Tools_Historic_Bilding_Corner",5)
(
	local sel_faces_ary=#()
	local del_faces_ary=#()
	local face_normal
	local face_center
	local a_verts=#(),a_faces=#(),a_smooth=#()
	local model_type
	local main_operation
	
	rollout frmmain "ģ;" width:168 height:72
	(
		button btn_high "߾" pos:[8,8] width:72 height:16
		button btn_low ";" pos:[88,8] width:72 height:16
		button btn_cancel "ȡ" pos:[88,48] width:72 height:16
		
		on btn_high pressed  do
		(	
			undo "HistoricBildingCornerType05" on
			(
				model_type="high"
				DestroyDialog frmmain
				main_operation()
			)
		)
		on btn_low pressed  do
		(
			undo "HistoricBildingCornerType05" on
			(
				model_type="low"
				DestroyDialog frmmain
				main_operation()
			)
		)
		on btn_cancel pressed do
		(
			DestroyDialog frmmain
		)
	)	
	
	fn main_operation=
	(
		sel_faces_ary=polyop.getfaceselection $ as array
		if sel_faces_ary.count==0 then return ok
		if model_type=="high" then
		(
			data=openfile ("mesh_data_type_05_high.txt")
			if data==undefined then
			(
				messageBox "ļmesh_data_type_05.txtʧ,ȡ."
				return ok
			)--end if
			
		)
		else
		(
			data=openfile ("mesh_data_type_05_low.txt")
			if data==undefined then
			(
				messageBox "ļmesh_data_type_05_low.txtʧ,ȡ."
				return ok
			)--end if		
		)--end if
		num_verts=readvalue data
		num_faces=readvalue data
		a_verts.count=num_verts
		a_faces.count=num_faces
		a_smooth.count=num_faces
		for v in 1 to num_verts do a_verts[v]=(readvalue data)
		for f in 1 to num_faces do a_faces[f]=(readvalue data)
		for s in 1 to num_faces do a_smooth[s]=(readvalue data)
		close data		
		
		for sel_face in sel_faces_ary do
		(
			face_verts=polyop.getvertsusingface $ sel_face as array
			if face_verts.count==4 then
			(
				face_normal=polyop.getfacenormal $ sel_face
				if face_normal.x==0 and face_normal.y==0 then continue
				face_center=polyop.getfacecenter $ sel_face
				
				z=normalize face_normal
				if z.x==0 and z.y==0 then
				(
					x=[1,0,0]
					y=[0,1,0]
				)
				else
				(	
					z2=copy z
					z2.z=0	
					x=normalize z2*(rotateZMatrix 90)
					y= cross z x
				)--end if
				m1=(matrix3 x y z face_center)
				
				v=#([0,0,0],[0,0,0],[0,0,0],[0,0,0])
				p1=undefined
				p2=undefined
				p3=undefined
				p4=undefined
				for i in 1 to 4 do
				(
					v[i]=(polyop.getvert $ face_verts[i])*(inverse m1)
					if v[i].x>0 and v[i].y>0 then p1= face_verts[i]
					if v[i].x<0 and v[i].y>0 then p2= face_verts[i]
					if v[i].x<0 and v[i].y<0 then p3= face_verts[i]
					if v[i].x>0 and v[i].y<0 then p4= face_verts[i]
				)--end for
				if p1==undefined or p2==undefinedor or p3==undefined or p4==undefined then exit loop
				x_factor=((distance (polyop.getvert $ p1) (polyop.getvert $ p2))+(distance (polyop.getvert $ p3) (polyop.getvert $ p4)))/2		
				y_factor=	((distance (polyop.getvert $ p1) (polyop.getvert $ p4))+(distance (polyop.getvert $ p3) (polyop.getvert $ p2)))/2
				m2=(matrix3 [x_factor,0,0] [0,y_factor,0] [0,0,y_factor] [0,0,0])
				
				--mesh
				new_mesh=mesh vertices:a_verts faces:a_faces name:(uniquename "ݼν05_")
				new_mesh.wirecolor=$.wirecolor
				new_mesh.material=$.material
				for f in 1 to num_faces do
				(
					setFaceSmoothGroup new_mesh f a_smooth[f]
				)--end for
				new_mesh.transform=m2*m1
				update new_mesh
				if model_type=="high" then
				(
					polyop.setvert $ p1 (a_verts[402]*m2*m1)
					polyop.setvert $ p2 (a_verts[70]*m2*m1)
					polyop.setvert $ p3 (a_verts[1]*m2*m1)
					polyop.setvert $ p4 (a_verts[333]*m2*m1)	
				)
				else
				(
					polyop.setvert $ p1 (a_verts[30]*m2*m1)
					polyop.setvert $ p2 (a_verts[154]*m2*m1)
					polyop.setvert $ p3 (a_verts[156]*m2*m1)
					polyop.setvert $ p4 (a_verts[1]*m2*m1)
				)--end if
				append del_faces_ary sel_face
			)--end if
		)--end for
		polyOp.deleteFaces $ del_faces_ary
		update $
	)--end function
	
	if classof $==Editable_Poly then
	(	
		createdialog frmmain style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox) modal:true
	)--end if
)--end script