macroScript Auto_Perron_Type_2 category:"Sheephao Tools" buttontext:"̨" tooltip:"̨2" Icon:#("Sheephao_Tools",9)

(		
	rollout frmmain "̨2" width:128 height:104
	(
		spinner spn_step_height "̤:" pos:[16,8] width:104 height:16 range:[-2000,2000,-150] type:#float scale:10
		spinner spn_step_width "̤:" pos:[16,24] width:104 height:16 enabled:true range:[-9000,9000,300] type:#float scale:10
		button btn_create "" pos:[8,80] width:112 height:16
		spinner spn_step_amount "̤:" pos:[16,40] width:104 height:16 enabled:true range:[1,1000,3] type:#integer scale:1
		spinner spn_total_height "ܸ߶:" pos:[16,56] width:104 height:16 enabled:true range:[-2000000,2000000,-450] type:#float scale:100
		on spn_step_height changed val do spn_total_height.value=spn_step_height.value*spn_step_amount.value
		on spn_step_amount changed val do spn_total_height.value=spn_step_height.value*spn_step_amount.value
		on spn_total_height changed val do
		(
			local temp_amount
			if spn_total_height.value==0 then
			(
				spn_total_height.value=spn_step_amount.value*spn_step_height.value
			) 		
			temp_amount=abs(spn_total_height.value/spn_step_height.value)
			case of
			(
				((temp_amount-floor(temp_amount))>=0.5):(temp_amount=ceil temp_amount)
				((temp_amount-floor(temp_amount))<0.5):(temp_amount=floor temp_amount)
			)
			if temp_amount<2 then temp_amount=2
			spn_step_height.value=spn_total_height.value/temp_amount
			spn_step_amount.value=temp_amount			
		)
		on btn_create pressed do
		(
			undo "̨2" on
			(
				local step_amount
				local step_height
				local step_width
				
				step_amount=spn_step_amount.value
				step_height=spn_step_height.value
				step_width=spn_step_width.value
				
				$.edgeExtrudeWidth = 0
				for i in 1 to step_amount-1 do
				(
					$.edgeExtrudeHeight = step_height
					$.EditablePoly.buttonOp #Extrude
					$.edgeExtrudeHeight =step_width
					$.EditablePoly.buttonOp #Extrude
				)
				$.edgeExtrudeHeight = step_height
				$.EditablePoly.buttonOp #Extrude
			)
		)
	)	
	
	
	
	createdialog frmmain pos:[32,70] style:#(#style_titlebar, #style_border, #style_sysmenu,#style_minimizebox)
)