macroScript MLine category:"Sheephao Tools" buttontext:"MLine" tooltip:"MLine" --Icon:#("Sheephao_Tools",1)
(	
	rollout frmmain "" width:160 height:88
	(
		GroupBox grp1 "" pos:[8,0] width:144 height:56
		spinner spn_left ":" pos:[24,15] width:120 height:16 range:[-100000,100000,100] type:#float scale:10
		spinner spn_right ":" pos:[24,32] width:120 height:16 range:[-100000,100000,100] type:#float scale:10
		button btn_create "" pos:[8,64] width:144 height:16
		
		local new_spline
		local pot
		local current_knot_index
		local points_array=#()
		local r_l,r_r

		--λʸ㺯
		fn offset_vector p1 p2 p3 r=
		(	
			z=[0,0,1]
			case of
			(
				(p1==p2):	
					(
						t2=normalize(p3-p1)
						r2=r
					)
				(p2==p3):
					(
						t2=normalize(p2-p1)
						r2=r
					)
				default:
					(
						v1=normalize(p1-p2)
						v3=normalize(p3-p2)
						if v1==v3 then
						(
							t2=normalize(p2-p1)
							r2=r
						)
						else
						(
							t2=normalize(v3-v1)
							g1=-r*(cross v1 z)
							g3=r*(cross v3 z)
							r2=r/(sqrt(0.5+(dot g1 g3)/(2*r*r)))
						)
					)
			)--end case
			return r2*(cross t2 z)
		)--end function
		
		--ƶcallback
		fn mouse_moving pot2 =
		(	
			local pos1,pos2,pos3
			--趨һڵ
			if points_array.count<2 then pos1=points_array[current_knot_index-1] else pos1=points_array[current_knot_index-2]
			pos2=points_array[current_knot_index-1]
			pos3=pot2
			v_offset=offset_vector pos1 pos2 pos3 200
			setknotpoint new_spline 1 (current_knot_index-1) (pos2+v_offset)
			setknotpoint new_spline 2 (current_knot_index-1) (pos2-v_offset)
			--趨ǰڵ
			pos1=points_array[current_knot_index-1]
			pos2=pot2
			pos3=pot2
			v_offset=offset_vector pos1 pos2 pos3 200
			setknotpoint new_spline 1 (current_knot_index) (pos2+v_offset)
			setknotpoint new_spline 2 (current_knot_index) (pos2-v_offset)
			updateShape new_spline
		)--end function
		
		--ӽڵ㺯
		fn pick_point last_point=
		(
			if last_point==false then
			(
				current_point=pickpoint snap:#3d
				if current_point==#escape or current_point==#rightclick then return ok else return current_point
			)
			else
			(
				addknot new_spline 1 #corner #line last_point
				addknot new_spline 2 #corner #line last_point
				current_knot_index=current_knot_index+1
				current_point=pickpoint snap:#3d rubberband:last_point mousemovecallback:mouse_moving
				if current_point==#escape or current_point==#rightclick then return ok else return current_point
			)
		)--end function
		
		--
		fn main_operation=
		(
			new_spline=splineshape()
			pot=pick_point false
			if pot==ok then return ok
			append points_array pot
			select new_spline
			new_spline.pos=pot
			addNewSpline new_spline
			addNewSpline new_spline
			addknot new_spline 1 #corner #line pot
			addknot new_spline 2 #corner #line pot
			current_knot_index=1
			while pot!=ok do
			(	
				pot=pick_point pot
				append points_array pot
			)
			
			deleteknot new_spline 1 current_knot_index
			deleteknot new_spline 2 current_knot_index
			deleteitem points_array points_array.count
			current_knot_index=current_knot_index-1
			if (numknots new_spline)<4 then delete new_spline
			else
			(
				pos1=points_array[current_knot_index-1]
				pos2=points_array[current_knot_index]
				pos3=pos2
				v_offset=offset_vector pos1 pos2 pos3 200
				setknotpoint new_spline 1 (current_knot_index) (pos2+v_offset)
				setknotpoint new_spline 2 (current_knot_index) (pos2-v_offset)
				if (numknots new_spline)>4 then
				(
					q=queryBox "պSpline?" title:"Sheephao Tools"
				)
				else q=false
				if q==true then
				(
					print points_array.count
					--λ
					pos1=points_array[points_array.count]
					pos2=points_array[1]
					pos3=points_array[2]
					v_offset=offset_vector pos1 pos2 pos3 200
					setknotpoint new_spline 1 1 (pos2+v_offset)
					setknotpoint new_spline 2 1 (pos2-v_offset)
					--յλ
					pos1=points_array[points_array.count-1]
					pos2=points_array[points_array.count]
					pos3=points_array[1]
					v_offset=offset_vector pos1 pos2 pos3 200
					setknotpoint new_spline 1 points_array.count (pos2+v_offset)
					setknotpoint new_spline 2 points_array.count (pos2-v_offset)
					close new_spline 1
					close new_spline 2
				)
				updateshape new_spline
			)
		)--end function
	
		on btn_create pressed  do
		(
			undo "MLine" on
			(
				main_operation()
			)--end undo
		)
	)	
	
	createdialog frmmain pos:[32,70]
)--end script